class droneci (

    $server_port = ':8080',

    # SSL
    $ssl_key = undef,
    $ssl_cert = undef,

    # Database
    $db_driver = 'sqlite3',
    $db_datasource = '/var/lib/drone/drone.sqlite',

    # GitHub
    $github_client = undef,
    $github_secret = undef,
    $github_orgs = undef,
    $github_open = undef,

    # GitHub
    $github_ent_client = undef,
    $github_ent_secret = undef,
    $github_ent_api = undef,
    $github_ent_url = undef,
    $github_ent_orgs = undef,
    $github_ent_open = undef,
    $github_ent_private_mode = undef,

    # Bitbucket
    $bitbucket_client = undef,
    $bitbucket_secret = undef,
    $bitbucket_open = undef,

    # GitLab
    $gitlab_url = undef,
    $gitlab_client = undef,
    $gitlab_secret = undef,
    $gitlab_skip_verify = undef,
    $gitlab_open = undef,

    # Gogs
    $gogs_url = undef,
    $gogs_secret = undef,
    $gogs_open = undef,

    # Smtp
    $smtp_host = undef,
    $smtp_port = undef,
    $smtp_from = undef,
    $smtp_user = undef,
    $smtp_pass = undef,

    # Docker
    $docker_cert = undef,
    $docker_key = undef,

    # Workers
    $worker_nodes = undef,

  ){

    if ( $ssl_key == undef and $ssl_cert != undef ) or
      ( $ssl_key != undef and $ssl_cert == undef ) {
      fail('Both ssl_key and ssl_cert should be specified')
    }

    ######################################################################
    # Checking Github parameters
    ######################################################################

    if ( $github_orgs != undef ) and ! is_array($github_orgs) {
      fail('Github_orgs should be an Array')
    }

    if ( $github_open != undef ) and ! is_bool($github_open) {
      fail('Github_open should be a Boolean')
    }

    ######################################################################
    # Checking Github Enterprise parameters
    ######################################################################

    if ( $github_ent_orgs != undef ) and ! is_array($github_ent_orgs) {
      fail('Github_ent_orgs should be an Array')
    }

    if ( $github_ent_open != undef ) and ! is_bool($github_ent_open) {
      fail('Github_ent_open should be a Boolean')
    }

    if ( $github_ent_private_mode != undef ) and ! is_bool($github_ent_private_mode) {
      fail('Github_ent_open should be a Boolean')
    }

    ######################################################################
    # Checking Bitbucket parameters
    ######################################################################

    if ( $bitbucket_open != undef ) and ! is_bool($bitbucket_open) {
      fail('Github_open should be a Boolean')
    }

    ######################################################################
    # Checking Gitlab parameters
    ######################################################################

    if ( $gitlab_open != undef ) and ! is_bool($gitlab_open) {
      fail('Github_open should be a Boolean')
    }

    if ( $gitlab_skip_verify != undef ) and ! is_bool($gitlab_skip_verify) {
      fail('Github_skip_verify should be a Boolean')
    }

    ######################################################################
    # Checking Gogs parameters
    ######################################################################

    if ( $gogs_open != undef ) and ! is_bool($gogs_open) {
      fail('Github_open should be a Boolean')
    }

    ######################################################################
    # Checking Worker parameters
    ######################################################################

    if ( $worker_nodes != undef ) and ! is_array($worker_nodes) {
      fail('Worker_nodes should be an Array')
    }

    class { 'droneci::install': }
    class { 'droneci::config': }
    class { 'droneci::service': }

    Class['droneci::install'] ->
    Class['droneci::config'] ->
    Class['droneci::service']

}
